import React from 'react';
import FormFileButton from './FormFileButton';
import FormFileInput from './FormFileInput';
import FormFileLabel from './FormFileLabel';
import FormFileText from './FormFileText';
import { BsPrefixPropsWithChildren, BsPrefixRefForwardingComponent } from './helpers';
export interface FormFileProps extends BsPrefixPropsWithChildren, Pick<React.HTMLAttributes<HTMLElement>, 'style'> {
    inputAs?: React.ElementType;
    id?: string;
    disabled?: boolean;
    label?: React.ReactNode;
    button?: React.ReactNode;
    isValid?: boolean;
    isInvalid?: boolean;
    feedback?: React.ReactNode;
    feedbackTooltip?: boolean;
    size?: 'sm' | 'lg';
}
declare type FormFile = BsPrefixRefForwardingComponent<'input', FormFileProps> & {
    Button: typeof FormFileButton;
    Input: typeof FormFileInput;
    Label: typeof FormFileLabel;
    Text: typeof FormFileText;
};
declare const FormFile: FormFile;
export default FormFile;
